/* initialize connection to server, get its Desktop-service and XComponentLoader interface */
xMsf=ooo.connect()   -- connect to server and retrieve remote multi server factory

-- Retrieve the Desktop object, we need its XComponentLoader interface
-- to load a new document
oDesktop         = xMsf~createInstance("com.sun.star.frame.Desktop")
xDesktop         = oDesktop~XDesktop          -- get desktop interface
xComponentLoader = xDesktop~XComponentLoader  -- get componentLoader interface

/* load an empty text document */
oSheetComponent = xComponentLoader~loadComponentFromURL("private:factory/scalc", "_blank", 0, .OOo~noProps)

xDocument=oSheetComponent~XSpreadSheetDocument
xSheets=xDocument~getSheets
xIndexSheets=xSheets~XIndexAccess
xSheet=xIndexSheets~getByIndex(0)~XSpreadSheet  -- get the spreadsheet interface for the sheet

-- Insert some dummy data
do i=0 to 3
	do j=0 to 3
		call OOo.setCell xSheet, i, j, i*j
	end
end

-- Set style
xStyleFamiliesSupplier=xDocument~XStyleFamiliesSupplier
xStyleFamilies = xStyleFamiliesSupplier~getStyleFamilies

xCellStyles=xStyleFamilies~getByName("CellStyles")~XNameAccess

xDocumentMultiServiceFactory=xDocument~XMultiServiceFactory

oStyleFamilyNameContainer=xCellStyles~XNameContainer

style = xDocumentMultiServiceFactory~createInstance("com.sun.star.style.CellStyle")
oStyleFamilyNameContainer~insertByName("My Style", style)

props = style~XPropertySet
props~setPropertyValue("IsCellBackgroundTransparent", box("boolean", .false))
props~setPropertyValue("CellBackColor", box("int", 6710932))   -- = hex 66 66 94
props~setPropertyValue("CharColor", box("int", "ff ff ff"x ~c2d))

cellRange = xSheet~getCellRangeByPosition(0, 0, 3, 3)
cellProperties=cellRange~XPropertySet

-- redefine properties of cells in range
--  !! Note for Rexx users: You must point BSF4Rexx to the right method
--     using the invokeStrict function with type indicators ("ST" for String)
cellProperties~bsf.invokeStrict("setPropertyValue", "ST", "CellStyle", "ST", "My Style")



::requires OOO.CLS   -- ooRexx support for OpenOffice.org


